#ifndef SEQCLTNH
#define SEQCLTNH

/* SeqCltn.h -- declarations for abstract sequential collections

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Collection.h"

extern Class class_SeqCltn;

class SeqCltn: public Collection {
public:
	SeqCltn() {}
	SeqCltn(fileDescTy&,SeqCltn&) {}
	SeqCltn(istream&,SeqCltn&) {}
	virtual obid& at(int i);
	virtual void atAllPut(const Object& ob);
	virtual void deepenShallowCopy();
	virtual obid doNext(DoCltnPos&);
	virtual obid first();
 	virtual const Class* isA();
	virtual int indexOf(const Object& ob);
	virtual int indexOfSubCollection(const SeqCltn& cltn, int start=0);
	virtual obid last();
	virtual void replaceFrom(int start, int stop, const SeqCltn& replacement, int startAt =0);
};

#endif
