#ifndef	SHAREDQUEUEH
#define	SHAREDQUEUEH

/* SharedQueue.h -- declarations for shared queues

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Arrayobid.h"
#include "Semaphore.h"

extern Class class_SharedQueue;

class SharedQueue : public Object {
	Arrayobid queue;
	int readPosition,writePosition;
	Semaphore valueAvailable;
	Semaphore spaceAvailable;
public:
	SharedQueue(UNSIGNED queueSize =CLTN_DEFAULT_CAPACITY);
	SharedQueue(fileDescTy&,SharedQueue&);
	SharedQueue(istream&,SharedQueue&);
	bool isFull()	{ return spaceAvailable.value() == 0; }
	virtual UNSIGNED capacity();
	virtual void deepenShallowCopy();
	virtual const Class* isA();
	virtual bool isEmpty();
	virtual obid next();
	virtual obid nextPut(const Object&);
	virtual void printOn(ostream& strm);
	virtual obid shallowCopy();		// shouldNotImplement
	virtual UNSIGNED size();
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
};

#endif
